<?xml version="1.0" encoding="UTF-8"?>
<xliff xmlns="urn:oasis:names:tc:xliff:document:1.1" version="1.1">
  <file original="NoName" source-language="en" datatype="plaintext" target-language="zh_Hans">
    <body>
      <trans-unit xml:space="preserve" approved="no" id="3a36128434342683" weblate-flags="safe-html, strict-same">
        <source>﻿[#regular] = Regular Containers</source>
        <target state="translated">[#regular] = 常规容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">1</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="3497adcbeb9e6e6f" weblate-flags="safe-html, strict-same">
        <source>:idprefix: regular_</source>
        <target state="translated">:idprefix: regular_</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">4</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="3bb8bcc398d43579" weblate-flags="safe-html, strict-same">
        <source>Boost.Unordered closed-addressing containers (`boost::unordered_set`, `boost::unordered_map`, `boost::unordered_multiset` and `boost::unordered_multimap`) are fully conformant with the C++ specification for unordered associative containers, so for those who know how to use `std::unordered_set`, `std::unordered_map`, etc., their homonyms in Boost.Unordered are drop-in replacements. The interface of open-addressing containers (`boost::unordered_node_set`, `boost::unordered_node_map`, `boost::unordered_flat_set` and `boost::unordered_flat_map`) is very similar, but they present some minor differences listed in the dedicated xref:compliance.adoc#compliance_open_addressing_containers[standard compliance section].</source>
        <target state="translated">Boost.Unordered 的闭寻址容器（ `boost::unordered++_++set` 、 `boost::unordered++_++map` 、 `boost::unordered++_++multiset` 与 `boost::unordered++_++multimap` ）完全符合 C{plus}{plus} 无序关联容器的标准规范。因此，对于熟悉 `std::unordered++_++set` 、 `std::unordered++_++map` 等用法的用户，可直接将其替换为Boost.Unordered 中的同名容器。开放寻址容器（ `boost::unordered++_++node++_++set` 、 `boost::unordered++_++node++_++map` 、 `boost::unordered++_++flat++_++set` 和 `boost::unordered++_++flat++_++map` ）的接口与之高度相似，但存在一些细微差异，详见专门的 xref:compliance.adoc#compliance_open_addressing_containers[标准符合性章节] 。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">6</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="922830c2bec979e6" weblate-flags="safe-html, strict-same">
        <source>For readers without previous experience with hash containers but familiar with normal associative containers (`std::set`, `std::map`, `std::multiset` and `std::multimap`), Boost.Unordered containers are used in a similar manner:</source>
        <target state="translated">对于没有哈希容器经验但熟悉常规关联容器（ `std::set` 、 `std::map` 、 `std::multiset` 和 `std::multimap` ）的读者，Boost.Unordered 容器的使用方式与之类似：</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">16</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="a4fa238294639eb0" weblate-flags="safe-html, strict-same">
        <source>But since the elements aren't ordered, the output of:</source>
        <target state="translated">但由于元素不按顺序存储，以下代码的输出结果：</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">32</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="289bad3b13b4289b" weblate-flags="safe-html, strict-same">
        <source>can be in any order. For example, it might be:</source>
        <target state="translated">可能以任意顺序输出。例如，结果可能为：</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">41</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="33099fbf4a57414d" weblate-flags="safe-html, strict-same">
        <source>There are other differences, which are listed in the xref:regular.adoc#comparison[Comparison with Associative Containers] section.</source>
        <target state="translated">其他差异列于 xref:regular.adoc#comparison[与关联容器的对比] 章节中。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">50</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="940df00904b59c51" weblate-flags="safe-html, strict-same">
        <source>Iterator Invalidation</source>
        <target state="translated">迭代器失效</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">53</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="56ce08fd00594514" weblate-flags="safe-html, strict-same">
        <source>It is not specified how member functions other than `rehash` and `reserve` affect the bucket count, although `insert` can only invalidate iterators when the insertion causes the container's load to be greater than the maximum allowed. For most implementations this means that `insert` will only change the number of buckets when this happens. Iterators can be invalidated by calls to `insert`, `rehash` and `reserve`.</source>
        <target state="translated">标准未明确规定除 `rehash` 和 `reserve` 之外的成员函数如何影响桶数量，但 `insert` 操作仅当导致容器负载超过最大允许值时才会使迭代器失效。在大多数实现中，这意味着 `insert` 仅在此种情况下才会改变桶的数量。迭代器可能因调用 `insert` 、 `rehash` 或 `reserve` 而失效。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">55</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="77536445db8c77cd" weblate-flags="safe-html, strict-same">
        <source>As for pointers and references, they are never invalidated for node-based containers (`boost::unordered_[multi]set`, `boost::unordered_[multi]map`, `boost::unordered_node_set`, `boost::unordered_node_map`), but they will be when rehashing occurs for `boost::unordered_flat_set` and `boost::unordered_flat_map`: this is because these containers store elements directly into their holding buckets, so when allocating a new bucket array the elements must be transferred by means of move construction.</source>
        <target state="translated">对于基于节点的容器（ `boost::unordered++_[++multi++]++set` 、 `boost::unordered++_[++multi++]++map` 、 `boost::unordered++_++node++_++set` 、 `boost::unordered++_++node++_++map` ），其指针和引用永远不会失效。但对于 `boost::unordered++_++flat++_++set` 和 `boost::unordered++_++flat++_++map` ，在发生重哈希时指针和引用将会失效：这是因为这些容器将元素直接存储在桶中，当分配新的桶数组时，必须通过移动构造来转移元素。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">62</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="07d7f690dc2d1dc9" weblate-flags="safe-html, strict-same">
        <source>In a similar manner to using `reserve` for ``vector``s, it can be a good idea to call `reserve` before inserting a large number of elements. This will get the expensive rehashing out of the way and let you store iterators, safe in the knowledge that they won't be invalidated. If you are inserting `n` elements into container `x`, you could first call:</source>
        <target state="translated">与为 `vector` 使用 `reserve` 类似，在插入大量元素之前调用 `reserve` 是一个好主意。这样可以避免代价高昂的重哈希操作，并且让你能够存储迭代器，确信它们不会被失效。如果你要向容器 `x` 插入 `n` 个元素，可以先调用：</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">70</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="2ab20775aea37213" weblate-flags="safe-html, strict-same">
        <source>``` x.reserve(n); ```</source>
        <target state="translated">``` x.reserve(n); ```</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">76</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="bdfc51537e205e83" weblate-flags="safe-html, strict-same">
        <source>`reserve(n)` reserves space for at least `n` elements, allocating enough buckets</source>
        <target state="translated">`reserve(n)` 为至少 `n` 个元素预留空间，分配足够数量的桶，</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">80</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="2b395d676ec59062" weblate-flags="safe-html, strict-same">
        <source>so as to not exceed the maximum load factor. + Because the maximum load factor is defined as the number of elements divided by the total number of available buckets, this function is logically equivalent to: + ``` x.rehash(std::ceil(n / x.max_load_factor())) ``` + See the xref:reference/unordered_map.adoc#unordered_map_rehash[reference for more details] on the `rehash` function.</source>
        <target state="translated">以确保不超过最大负载因子。由于最大负载因子定义为元素数量除以可用桶的总数，该函数在逻辑上等价于：
```cppx.rehash(std::ceil(n / x.max_load_factor()))```
有关 `rehash` 函数的更多详细信息，请参阅 xref:reference/unordered_map.adoc#unordered_map_rehash[参考文档]。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">81</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="ce1c41e996006f5f" weblate-flags="safe-html, strict-same">
        <source>:idprefix: comparison_</source>
        <target state="translated">:idprefix: comparison_</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">94</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="aa8e565a28ffb54e" weblate-flags="safe-html, strict-same">
        <source>Comparison with Associative Containers</source>
        <target state="translated">与关联容器的对比</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">96</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":100" weblate-flags="safe-html, strict-same">
        <source>Associative Containers</source>
        <target state="translated">关联容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":100" weblate-flags="safe-html, strict-same">
        <source>Unordered Associative Containers</source>
        <target state="translated">无序关联容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="d7f46c5af8b80084" weblate-flags="safe-html, strict-same">
        <source>Parameterized by an ordering relation `Compare`</source>
        <target state="translated">通过排序关系 `Compare` 进行 参数化</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="9525738169e202d6" weblate-flags="safe-html, strict-same">
        <source>Parameterized by a function object `Hash` and an equivalence relation `Pred`</source>
        <target state="translated">由函数对象`哈希对象`和等价关系`谓词对象`参数化。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="9b37d868daf5b710" weblate-flags="safe-html, strict-same">
        <source>Keys can be compared using `key_compare` which is accessed by member function `key_comp()`, values can be compared using `value_compare` which is accessed by member function `value_comp()`.</source>
        <target state="translated">键可通过成员函数`key_comp()`获取的`键比较对象`进行比较，值可通过成员函数`value_comp()`获取的`值比较对象`进行比较。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="bb25b36fd25ff8ad" weblate-flags="safe-html, strict-same">
        <source>Keys can be hashed using `hasher` which is accessed by member function `hash_function()`, and checked for equality using `key_equal` which is accessed by member function `key_eq()`. There is no function object for compared or hashing values.</source>
        <target state="translated">键可通过成员函数`hash_function()`获取的`哈希对象`进行哈希计算，并通过成员函数`key_eq()`获取的`键相等比较对象`检查是否相等。不存在用于值比较或值哈希的函数对象。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="a84f1d123aad2069" weblate-flags="safe-html, strict-same">
        <source>Constructors have optional extra parameters for the comparison object.</source>
        <target state="translated">构造函数包含用于比较对象的可选额外参数。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="45f8c8a969b87b14" weblate-flags="safe-html, strict-same">
        <source>Constructors have optional extra parameters for the initial minimum number of buckets, a hash function and an equality object.</source>
        <target state="translated">构造函数包含可选的额外参数，用于指定初始最小哈希桶数量、哈希函数以及相等性判断对象。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="461a66e4b8aa1d02" weblate-flags="safe-html, strict-same">
        <source>Keys `k1`, `k2` are considered equivalent if `!Compare(k1, k2) &amp;&amp; !Compare(k2, k1)`.</source>
        <target state="translated">若`!对象(k1, k2) &amp;amp;&amp;amp; !对象(k2, k1)`，则键`k1`、`k2`视为等价。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="c2878776d9198740" weblate-flags="safe-html, strict-same">
        <source>Keys `k1`, `k2` are considered equivalent if `Pred(k1, k2)`</source>
        <target state="translated">若`谓词对象(k1, k2)成立`，则键`k1`、`k2`视为等价。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="68f8af08c22a0f38" weblate-flags="safe-html, strict-same">
        <source>Member function `lower_bound(k)` and `upper_bound(k)`</source>
        <target state="translated">成员函数`lower_bound(k)`和`upper_bound(k)`</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="7ee4768c03f87eac" weblate-flags="safe-html, strict-same">
        <source>No equivalent. Since the elements aren't ordered `lower_bound` and `upper_bound` would be meaningless.</source>
        <target state="translated">无对应接口。由于元素无序，`lower_bound `和 `upper_bound `无实际意义。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="5a169aaa85ef63f0" weblate-flags="safe-html, strict-same">
        <source>`equal_range(k)` returns an empty range at the position that `k` would be inserted if `k` isn't present in the container.</source>
        <target state="translated">若键k不存在于容器中，equal_range(k)会在k 应插入的位置返回一个空区间。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="10ce7a4aa7e3d60d" weblate-flags="safe-html, strict-same">
        <source>`equal_range(k)` returns a range at the end of the container if `k` isn't present in the container. It can't return a positioned range as `k` could be inserted into multiple place. +</source>
        <target state="translated">equal_range(k) 若键k不存在于容器中，则返回容器末尾的区间。该函数无法返回定位区间，因为k可被插入到多个位置。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">100</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="c153ea64f82c320d" weblate-flags="safe-html, strict-same">
        <source>**Closed-addressing containers:** To find out the bucket that `k` would be inserted into use `bucket(k)`. But remember that an insert can cause the container to rehash - meaning that the element can be inserted into a different bucket.</source>
        <target state="translated">闭散列容器：使用 bucket (k) 可确定键 k 待插入的哈希桶。需注意，插入操作可能触发容器重新哈希，元素最终会被存入其他哈希桶。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">120</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="c328ac3380b81bf1" weblate-flags="safe-html, strict-same">
        <source>`iterator`, `const_iterator` are of the bidirectional category.</source>
        <target state="translated">`迭代器`、`常迭代器`的迭代类别为双向迭代器。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">122</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="43b090673b404b7f" weblate-flags="safe-html, strict-same">
        <source>`iterator`, `const_iterator` are of at least the forward category.</source>
        <target state="translated">`迭代器`、`常迭代器`的迭代类别至少为前向迭代器。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">122</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="ae7309af5cd61f6a" weblate-flags="safe-html, strict-same">
        <source>Iterators, pointers and references to the container's elements are never invalidated.</source>
        <target state="translated">指向容器元素的迭代器、指针和引用永远不会失效。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">122</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="6d86db5d2ca20b41" weblate-flags="safe-html, strict-same">
        <source>xref:regular.adoc#regular_iterator_invalidation[Iterators can be invalidated by calls to insert or rehash]. +</source>
        <target state="translated">xref:regular.adoc#regular_iterator_invalidation [调用 insert 或 rehash 可能会导致迭代器失效]。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">122</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="e873f8a4c172d508" weblate-flags="safe-html, strict-same">
        <source>**Node-based containers:** Pointers and references to the container's elements are never invalidated. + **Flat containers:** Pointers and references to the container's elements are invalidated when rehashing occurs.</source>
        <target state="translated">基于节点的容器：指向容器元素的指针和引用永远不会失效。
扁平容器：发生重新哈希时，指向容器元素的指针和引用将会失效。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">127</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="efa7a852900fc45d" weblate-flags="safe-html, strict-same">
        <source>Iterators iterate through the container in the order defined by the comparison object.</source>
        <target state="translated">迭代器按照比较对象定义的顺序遍历容器。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="9c1e546c3f6d0ea0" weblate-flags="safe-html, strict-same">
        <source>Iterators iterate through the container in an arbitrary order, that can change as elements are inserted, although equivalent elements are always adjacent.</source>
        <target state="translated">迭代器以任意顺序遍历容器，该顺序会随元素插入发生变化，但等价元素始终保持相邻。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="6b9ba61ae81aaf60" weblate-flags="safe-html, strict-same">
        <source>No equivalent</source>
        <target state="translated">无对应接口</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="f1132e9f32f3e7d6" weblate-flags="safe-html, strict-same">
        <source>**Closed-addressing containers:** Local iterators can be used to iterate through individual buckets. (The order of local iterators and iterators aren't required to have any correspondence.)</source>
        <target state="translated">闭散列容器：本地迭代器可用于遍历各个哈希桶。（本地迭代器与迭代器的顺序无需存在对应关系。）</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="98e40781c42462ae" weblate-flags="safe-html, strict-same">
        <source>Can be compared using the `==`, `!=`, `&lt;`, `\&lt;=`, `&gt;`, `&gt;=` operators.</source>
        <target state="translated">可使用`==`, `!=`, `&amp;lt;`, `\&amp;lt;=`, `&amp;gt;`, `&amp;gt;=`运算符进行比较。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="55a943f6c7b3da75" weblate-flags="safe-html, strict-same">
        <source>Can be compared using the `==` and `!=` operators.</source>
        <target state="translated">可使用`==` 和`!=`运算符进行比较。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="b917a8ecc3451ba2" weblate-flags="safe-html, strict-same">
        <source>When inserting with a hint, implementations are permitted to ignore the hint.</source>
        <target state="translated">使用提示迭代器插入元素时，实现允许忽略该提示。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">130</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="d2aefa81f6811453" weblate-flags="safe-html, strict-same">
        <source>---</source>
        <target state="translated">---</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">144</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="79f418f2357fd450" weblate-flags="safe-html, strict-same">
        <source>Operation</source>
        <target state="translated">操作</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>Associative Containers</source>
        <target state="translated">关联容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>Unordered Associative Containers</source>
        <target state="translated">无序关联容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="6a32ee41f9142d3f" weblate-flags="safe-html, strict-same">
        <source>Construction of empty container</source>
        <target state="translated">空容器的构造</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="59b4ebe1f20ad9d9" weblate-flags="safe-html, strict-same">
        <source>constant</source>
        <target state="translated">常数级</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="a0da8e4e8b2f21fc" weblate-flags="safe-html, strict-same">
        <source>O(_n_) where _n_ is the minimum number of buckets.</source>
        <target state="translated">O(_n_)，其中 _n_ 是最小桶数。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="4bec0c6e452e2fe6" weblate-flags="safe-html, strict-same">
        <source>Construction of container from a range of _N_ elements</source>
        <target state="translated">由_N_元素的区间构造容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="b5c79773a2eb476d" weblate-flags="safe-html, strict-same">
        <source>O(_N log N_), O(_N_) if the range is sorted with `value_comp()`</source>
        <target state="translated">O(_N log N_)，如果区间已按 `value_comp()` 排序则为 O(_N_)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="148cc207e0a897cb" weblate-flags="safe-html, strict-same">
        <source>Average case O(_N_), worst case O(_N^2^_)</source>
        <target state="translated">平均时间复杂度  O(_N_)，最坏时间复杂度 O(_N^2^_)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="1939cce2011037a5" weblate-flags="safe-html, strict-same">
        <source>Insert a single element</source>
        <target state="translated">插入单个元素</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>logarithmic</source>
        <target state="translated">对数级</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="55b43271a723b369" weblate-flags="safe-html, strict-same">
        <source>Average case constant, worst case linear</source>
        <target state="translated">平均情况为常数时间，最坏情况为线性时间</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="de1a1b2004f8be77" weblate-flags="safe-html, strict-same">
        <source>Insert a single element with a hint</source>
        <target state="translated">带提示插入单个元素</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="fede3d5baadd71ff" weblate-flags="safe-html, strict-same">
        <source>Amortized constant if `t` elements inserted right after hint, logarithmic otherwise</source>
        <target state="translated">若在提示位置后直接插入t个元素，则为均摊常数时间；否则为对数时间</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="f936c0b13dcd6134" weblate-flags="safe-html, strict-same">
        <source>Average case constant, worst case linear (ie. the same as a normal insert).</source>
        <target state="translated">平均情况为常数时间，最坏情况为线性时间（即与普通插入操作一致）。</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="e93a85a4b759eac2" weblate-flags="safe-html, strict-same">
        <source>Inserting a range of _N_ elements</source>
        <target state="translated">插入_N_元素的区间</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="4f0c028b8dcbfdf5" weblate-flags="safe-html, strict-same">
        <source>_N_ log(`size()` + _N_)</source>
        <target state="translated">_N_ log(`size()` + _N_)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="66f2c4d796092c21" weblate-flags="safe-html, strict-same">
        <source>Average case O(_N_), worst case O(_N_ * `size()`)</source>
        <target state="translated">平均时间复杂度 O(_N_)，最坏时间复杂度O (_N_ * `size()`)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="63cecb068bb63c74" weblate-flags="safe-html, strict-same">
        <source>Erase by key, `k`</source>
        <target state="translated">按键`k`移除</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>O(log(`size()`) + `count(k)`)</source>
        <target state="translated">O(log(`size()`) + `count(k)`)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>Average case: O(`count(k)`), Worst case: O(`size()`)</source>
        <target state="translated">平均情况：O(`count(k)`)，最坏情况：O(`size()`)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="739b28fb372d3b5c" weblate-flags="safe-html, strict-same">
        <source>Erase a single element by iterator</source>
        <target state="translated">通过迭代器移除单个元素</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="3ee7ca443c70ace8" weblate-flags="safe-html, strict-same">
        <source>Amortized constant</source>
        <target state="translated">均摊常数时间</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>Average case: O(1), Worst case: O(`size()`)</source>
        <target state="translated">平均情况：O (1)，最坏情况：O(`size()`)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="0a8338c9612f152a" weblate-flags="safe-html, strict-same">
        <source>Erase a range of _N_ elements</source>
        <target state="translated">移除 _N_元素的区间</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="ae96df07a3830097" weblate-flags="safe-html, strict-same">
        <source>O(log(`size()`) + _N_)</source>
        <target state="translated">O(log(`size()`) + _N_)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="d789e8923646b0ba" weblate-flags="safe-html, strict-same">
        <source>Average case: O(_N_), Worst case: O(`size()`)</source>
        <target state="translated">平均情况：O(_N_)，最坏情况： O(`size()`)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="244c7ccfdd94045b" weblate-flags="safe-html, strict-same">
        <source>Clearing the container</source>
        <target state="translated">清空容器</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id=":148" weblate-flags="safe-html, strict-same">
        <source>O(`size()`)</source>
        <target state="translated">O(`size()`)</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="eacc3ade158481b6" weblate-flags="safe-html, strict-same">
        <source>Find</source>
        <target state="translated">查找</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="5afb888437850f1e" weblate-flags="safe-html, strict-same">
        <source>Count</source>
        <target state="translated">计数</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="b938a6d8ae4a621a" weblate-flags="safe-html, strict-same">
        <source>`equal_range(k)`</source>
        <target state="translated">`equal_range(k)`</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="f1a8c91c4dbc0c1b" weblate-flags="safe-html, strict-same">
        <source>`lower_bound`,`upper_bound`</source>
        <target state="translated">`lower_bound`,`upper_bound`</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
      <trans-unit xml:space="preserve" approved="no" id="534c68b6f2c91f78" weblate-flags="safe-html, strict-same">
        <source>n/a</source>
        <target state="translated">n/a</target>
        <context-group name="" purpose="location">
          <context context-type="sourcefile"></context>
          <context context-type="linenumber">148</context>
        </context-group>
      </trans-unit>
    </body>
  </file>
</xliff>
